Skip to main content

send()

Description​

Sends a necessary HTTP request to the server and returns a promise with or without data depending on the request

All requests to the server are made with the send() method which is a part of the RestDataProvider service.

Usage​

send(
url: string,
method: "GET" | "POST" | "PUT" | "DELETE" | string,
data?: object,
headers?: object,
): Promise<obj[]>

Parameters​

NameTypeDescription
urlstringRequired. A path to the server where a request is sent to.
methodstringRequired. An HTTP method type (Get, Post, Put, Delete)
dataobjectOptional. Parameters that are sent to the server. By default, parameters of the fired event are sent. But you are free to add additional parameters with the custom object. See the examples below.
headersobjectOptional. A default header is the Content-Type header set to application/json. More optional headers can be added with the customHeaders parameter. See the examples below.

Response​

The method returns the promise object with or without data depending on the request.

A promise is returned in response to the success request status. In case of the failed request (response.status == 500), an exception with an error text is thrown.

Examples​

The following examples demonstrate how to add more headers to the send() method.

const customHeaders = {
"Authorization": "Bearer",
"Custom header": "some value",
};

api.intercept("add-row", obj => {
restDataProvider.send("", "POST", obj, customHeaders);
});

Or you can add headers in the way as below by redefining RestDataProvider, which can give you more control of the data you send to the server:

<script setup>
import { RestDataProvider } from "@svar-ui/grid-data-provider";
import { Grid } from "@svar-ui/vue-grid";
import { ref } from "vue";

const columns = [
{
id: "name",
header: "Title",
editor: "text",
},
{
id: "year",
header: "Year",
editor: "text",
},
];

const data = ref([]);

class MyDataProvider extends RestDataProvider {
send(url, method, data, headers) {
headers = { ...headers, SomeToken: "abc" };
return super.send(url, method, data, headers);
}
}

const provider = new MyDataProvider("https://some-backend-url");

provider.getData().then((v) => (data.value = v));

const init = (api) => {
api.setNext(provider);
};

</script>

<template>
<Grid :data="data" :columns="columns" :init="init" />
</template>

The example below shows how to add additional parameters to the request. You don't need to call the send() method manually here as it's called via the api.setNext() method.

<script setup>
import { RestDataProvider } from "@svar-ui/grid-data-provider";
import { Grid } from "@svar-ui/vue-grid";
import { ref } from "vue";

const columns = [
{
id: "name",
header: "Title",
editor: "text",
},
{
id: "year",
header: "Year",
editor: "text",
},
];

const data = ref([]);

const provider = new RestDataProvider("https://some-backend-url");

provider.getData().then((v) => (data.value = v));

const init = (api) => {
api.setNext(provider);
api.intercept("update-row", (ev) => {
ev.custom = "custom event";
});
}

</script>

<template>
<Grid :data="data" :columns="columns" :init="init" />
</template>

Related articles:

Skip to main content

send()

Description​

Sends a necessary HTTP request to the server and returns a promise with or without data depending on the request

All requests to the server are made with the send() method which is a part of the RestDataProvider service.

Usage​

send(
url: string,
method: "GET" | "POST" | "PUT" | "DELETE" | string,
data?: object,
headers?: object,
): Promise<obj[]>

Parameters​

NameTypeDescription
urlstringRequired. A path to the server where a request is sent to.
methodstringRequired. An HTTP method type (Get, Post, Put, Delete)
dataobjectOptional. Parameters that are sent to the server. By default, parameters of the fired event are sent. But you are free to add additional parameters with the custom object. See the examples below.
headersobjectOptional. A default header is the Content-Type header set to application/json. More optional headers can be added with the customHeaders parameter. See the examples below.

Response​

The method returns the promise object with or without data depending on the request.

A promise is returned in response to the success request status. In case of the failed request (response.status == 500), an exception with an error text is thrown.

Examples​

The following examples demonstrate how to add more headers to the send() method.

const customHeaders = {
"Authorization": "Bearer",
"Custom header": "some value",
};

api.intercept("add-row", obj => {
restDataProvider.send("", "POST", obj, customHeaders);
});

Or you can add headers by redefining RestDataProvider, which can give you more control of the data you send to the server:

import { RestDataProvider } from "@svar-ui/grid-data-provider";
import { Grid } from "@svar-ui/react-grid";
import { useState, useEffect } from "react";

const columns = [
{
id: "name",
header: "Title",
editor: "text",
},
{
id: "year",
header: "Year",
editor: "text",
},
];

function MyGridComponent() {
const [data, setData] = useState([]);

class MyDataProvider extends RestDataProvider {
send(url, method, data, headers) {
headers = { ...headers, SomeToken: "abc" };
return super.send(url, method, data, headers);
}
}

const provider = new MyDataProvider("https://some-backend-url");

useEffect(() => {
provider.getData().then((v) => setData(v));
}, []);

const init = (api) => {
api.setNext(provider);
};

return <Grid data={data} columns={columns} init={init} />;
}

The example below shows how to add additional parameters to the request. You don't need to call the send() method manually here as it's called via the api.setNext() method.

import { RestDataProvider } from "@svar-ui/grid-data-provider";
import { Grid } from "@svar-ui/react-grid";
import { useState, useEffect } from "react";

const columns = [
{
id: "name",
header: "Title",
editor: "text",
},
{
id: "year",
header: "Year",
editor: "text",
},
];

function MyGridComponent() {
const [data, setData] = useState([]);

const provider = new RestDataProvider("https://some-backend-url");

useEffect(() => {
provider.getData().then((v) => setData(v));
}, []);

const init = (api) => {
api.setNext(provider);
api.intercept("update-row", (ev) => {
ev.custom = "custom event";
});
};

return <Grid data={data} columns={columns} init={init} />;
}

Related articles: